/***************************************************************************
 *            packet_processor2.h
 *
 *  Mon Apr  4 10:48:55 2005
 *  Copyright  2005  User
 *  Email
 ****************************************************************************/

/*
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Library General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */
 
typedef struct kismet_server_struct
	{
	//char IP[20];
	string IP;	
	int socket;
	FILE *filedes;
	};	 


typedef struct socket_fd_structure
	{
	int socket_connected;
	FILE* filedes_connected;
	};
	
typedef struct logfile_structure
	{
	//string path_to_file;	
	char file_name[200];
	FILE* filedes_connected;
	unsigned long int last_saved_bin;	
	};
	
	
	
	
void kismet_multiple(int s,
vector<packet_info>& listpacket1,
vector<packet_info>& listpacket2,
//list of merged packets
map<uint64_t,packet_info>& mergepacket,
// per second packet qty traffic information
map<unsigned long,unsigned int>& traffic_bin,
// file descriptors
FILE *packlog1,
FILE *packlog2,
FILE *mergepacklog,
FILE *client_fd1,
FILE *client_fd2,
int& client_socket1,
int& client_socket2,
vector<kismet_server_struct>& kismet_servers,
map<mac_addr,logfile_structure>& logfiles
);

// prototype to merge insertion function

void packinsert(map<uint64_t,packet_info>& mergepacket_ins, packet_info &packtoinsert);

// prototype for packet comparison function

int packet_equal_mine(map<uint64_t,packet_info>::iterator search_index,packet_info &packtoinsert);

// this function saves packet traffic at the end of the mergefile

void save_packets(map<unsigned long,unsigned int>& traffic,FILE* logfile);

// structure of traffic bin

typedef struct bin_type
	{
	unsigned long int seconds;
	unsigned int packets;
	} ;

	
// for each of the sources there are time_bins that contain:	
	
typedef struct bin_info
	{
	unsigned long int traffic_in_bits;
	unsigned int traffic_in_packets;		
	unsigned long int traffic_out_bits;
	unsigned int traffic_out_packets;
	unsigned int power;
	unsigned int retransmission;
	unsigned int mode;
	unsigned int bandwidth;
	int saved;		
	};		
	
// holds a map with all the info_bins for a certain source
	
typedef map<unsigned long int, bin_info> device_info;


	
	
enum {
   PACKET_TRAFFIC_IN,
   PACKET_TRAFFIC_OUT,
   BIT_TRAFFIC_IN,
   BIT_TRAFFIC_OUT,
   TOTAL_TRAFFIC,
   CONNECTION_SPEED,
   POWER,
   RETRY_TIMES,
   LAST	
};
